## quickflux 1.1.3+git20201110.2a37acf

=== CMakeLists.txt ===
#
# To build it with cmake, you should register qml types explicitly by calling registerQuickFluxQmlTypes() in your main.cpp
# See examples/middleware for example
#

cmake_minimum_required(VERSION 3.0.0)
project(quickflux VERSION 1.1.3)

option(quickflux_INSTALL "Enable the installation of targets." ON)

if(MSVC)
  set_property (GLOBAL PROPERTY USE_FOLDERS ON)
endif()

set(SRC_DIR "${PROJECT_SOURCE_DIR}/src")

include(GNUInstallDirs)
find_package(Qt5 COMPONENTS Core Quick Qml Gui CONFIG REQUIRED)

set(quickflux_PRIVATE_SOURCES
  ${SRC_DIR}/priv/qfhook.cpp
  ${SRC_DIR}/priv/qfmiddlewareshook.cpp
  ${SRC_DIR}/priv/qfsignalproxy.cpp
  ${SRC_DIR}/priv/quickfluxfunctions.cpp
  )

set(quickflux_PUBLIC_SOURCES
  ${SRC_DIR}/qfactioncreator.cpp
  ${SRC_DIR}/qfappdispatcher.cpp
  ${SRC_DIR}/qfapplistener.cpp
  ${SRC_DIR}/qfapplistenergroup.cpp
  ${SRC_DIR}/qfappscript.cpp
  ${SRC_DIR}/qfappscriptdispatcherwrapper.cpp
  ${SRC_DIR}/qfappscriptgroup.cpp
  ${SRC_DIR}/qfappscriptrunnable.cpp
  ${SRC_DIR}/qfdispatcher.cpp
  ${SRC_DIR}/qffilter.cpp
  ${SRC_DIR}/qfhydrate.cpp
  ${SRC_DIR}/qfkeytable.cpp
  ${SRC_DIR}/qflistener.cpp
  ${SRC_DIR}/qfmiddleware.cpp
  ${SRC_DIR}/qfmiddlewarelist.cpp
  ${SRC_DIR}/qfobject.cpp
  ${SRC_DIR}/qfqmltypes.cpp
  ${SRC_DIR}/qfstore.cpp
  )

set(quickflux_PRIVATE_HEADERS
  ${SRC_DIR}/priv/qfappscriptdispatcherwrapper.h
  ${SRC_DIR}/priv/qfappscriptrunnable.h
  ${SRC_DIR}/priv/qfhook.h
  ${SRC_DIR}/priv/qflistener.h
  ${SRC_DIR}/priv/qfmiddlewareshook.h
  ${SRC_DIR}/priv/qfsignalproxy.h
  ${SRC_DIR}/priv/quickfluxfunctions.h
  )

set(quickflux_PUBLIC_HEADERS
  ${SRC_DIR}/qfactioncreator.h
  ${SRC_DIR}/QFAppDispatcher
  ${SRC_DIR}/qfapplistener.h
  ${SRC_DIR}/qfapplistenergroup.h
  ${SRC_DIR}/qfappscript.h
  ${SRC_DIR}/qfappdispatcher.h
  ${SRC_DIR}/qfappscriptgroup.h
  ${SRC_DIR}/qfdispatcher.h
  ${SRC_DIR}/qffilter.h
  ${SRC_DIR}/qfhydrate.h
  ${SRC_DIR}/QFKeyTable
  ${SRC_DIR}/qfkeytable.h
  ${SRC_DIR}/qfmiddleware.h
  ${SRC_DIR}/qfmiddlewarelist.h
  ${SRC_DIR}/qfobject.h
  ${SRC_DIR}/qfstore.h
  ${SRC_DIR}/QuickFlux
  )

source_group(include FILES
  ${quickflux_PRIVATE_HEADERS}
  ${quickflux_PUBLIC_HEADERS}
  )

if(MSVC)
  source_group("Source Files" FILES ${quickflux_PUBLIC_SOURCES})
  source_group("Source Files\\Private" FILES ${quickflux_PRIVATE_SOURCES})
  source_group("Header Files" FILES ${quickflux_PUBLIC_HEADERS})
  source_group("Header Files\\Private" FILES ${quickflux_PRIVATE_HEADERS})
  source_group("Source Files\\MOC" REGULAR_EXPRESSION "moc*")
endif()

add_library(quickflux STATIC
  ${quickflux_PRIVATE_SOURCES}
  ${quickflux_PRIVATE_HEADERS}
  ${quickflux_PUBLIC_SOURCES}
  ${quickflux_PUBLIC_HEADERS}
  ${moc}
  )
add_library(QuickFlux::quickflux ALIAS quickflux)

target_link_libraries(quickflux
  PUBLIC
  Qt5::Qml
  Qt5::Quick
  Qt5::Core
  )

target_include_directories(quickflux
  PUBLIC
  "$<BUILD_INTERFACE:${SRC_DIR}>"
  "$<INSTALL_INTERFACE:include/quickflux>"
  )

set_target_properties(quickflux PROPERTIES
  AUTOMOC TRUE
  DEBUG_POSTFIX d
  )

if(quickflux_INSTALL)

  install(TARGETS quickflux EXPORT QuickFluxTargets
    LIBRARY DESTINATION "${CMAKE_INSTALL_LIBDIR}"
    ARCHIVE DESTINATION "${CMAKE_INSTALL_LIBDIR}"
    RUNTIME DESTINATION "${CMAKE_INSTALL_BINDIR}"
    INCLUDES DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/quickflux"
    )

  install(FILES
    ${quickflux_PUBLIC_HEADERS}
    DESTINATION include/quickflux
    )
  install(FILES
    ${quickflux_PRIVATE_HEADERS}
    DESTINATION include/quickflux/priv
    )


  include(CMakePackageConfigHelpers)
  write_basic_package_version_file(
      ${CMAKE_BINARY_DIR}/cmake/QuickFluxVersion.cmake
      VERSION ${PROJECT_VERSION}
      COMPATIBILITY SameMajorVersion
  )

  # installation - build tree specific package config files
  export(EXPORT QuickFluxTargets FILE ${CMAKE_BINARY_DIR}/QuickFluxTargets.cmake)
  configure_file(${PROJECT_SOURCE_DIR}/QuickFluxConfig.cmake.in
      ${CMAKE_BINARY_DIR}/QuickFluxConfig.cmake
      COPYONLY
  )

  # installation - relocatable package config files
  configure_package_config_file(${PROJECT_SOURCE_DIR}/QuickFluxConfig.cmake.in
                                ${CMAKE_CURRENT_BINARY_DIR}/cmake/QuickFluxConfig.cmake
                                INSTALL_DESTINATION cmake
  )

  set(CONFIG_PACKAGE_LOCATION ${CMAKE_INSTALL_LIBDIR}/cmake/QuickFlux)

  install(EXPORT QuickFluxTargets
      FILE QuickFluxTargets.cmake
      NAMESPACE QuickFlux::
      DESTINATION ${CONFIG_PACKAGE_LOCATION}
  )

  install(FILES
      ${CMAKE_BINARY_DIR}/cmake/QuickFluxConfig.cmake
      ${CMAKE_BINARY_DIR}/cmake/QuickFluxVersion.cmake
      DESTINATION ${CONFIG_PACKAGE_LOCATION}
  )

endif()

=== examples/middleware/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.8.2)

project(middleware)

set(CMAKE_INCLUDE_CURRENT_DIR ON)

set(CMAKE_AUTOMOC ON)

find_package(Qt5Core REQUIRED)

include_directories(${Qt5Qml_INCLUDE_DIRS})
include_directories(${Qt5Gui_INCLUDE_DIRS})

#include("${CMAKE_CURRENT_SOURCE_DIR}/../../CMakeLists.txt")

# Generate rules for building source files from the resources
qt5_add_resources(QRCS qml.qrc)

add_subdirectory(${CMAKE_CURRENT_SOURCE_DIR}/../../ ${CMAKE_CURRENT_BINARY_DIR}/quickflux)

message(STATUS "test" ${quickflux_SOURCES})

# Tell CMake to create the middleware executable
add_executable(middleware main.cpp ${QRCS} quickflux)

#target_link_libraries(middleware ${CMAKE_CURRENT_BINARY_DIR}/quickflux/libquickflux.a)
link_directories(quickflux)
target_link_libraries(middleware  quickflux)

qt5_use_modules(middleware Qml Gui)

=== examples/todo/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1.0)

project(todo)

set(CMAKE_VERBOSE_MAKEFILE ON)

set(CMAKE_INCLUDE_CURRENT_DIR ON)

set(CMAKE_AUTOMOC ON)

set(CMAKE_AUTOUIC ON)

set(CMAKE_AUTORCC ON)

find_package(Qt5Qml CONFIG REQUIRED)
find_package(Qt5Gui CONFIG REQUIRED)
find_package(Qt5Core CONFIG REQUIRED)
find_package(Qt5Quick CONFIG REQUIRED)

set(todo_SRCS
  main.cpp
  qml.qrc
  )

include(ExternalProject)

ExternalProject_Add(QuickFlux
  PREFIX "${PROJECT_BINARY_DIR}/QuickFlux-build"
  SOURCE_DIR "${PROJECT_SOURCE_DIR}/../.."
  CMAKE_ARGS "-DCMAKE_PREFIX_PATH=${CMAKE_PREFIX_PATH}"
             "-DCMAKE_INSTALL_PREFIX=${PROJECT_BINARY_DIR}/QuickFlux"
             "-DCMAKE_INSTALL_LIBDIR=${PROJECT_BINARY_DIR}/QuickFlux/lib"
             "-DCMAKE_BUILD_TYPE=${CMAKE_BUILD_TYPE}"
  )

link_directories("${PROJECT_BINARY_DIR}/QuickFlux/lib")
include_directories("${PROJECT_BINARY_DIR}/QuickFlux/include/quickflux")

add_executable(todo WIN32 ${todo_SRCS})
add_dependencies(todo QuickFlux)

target_link_libraries(todo debug quickfluxd optimized quickflux)
target_link_libraries(todo Qt5::Qml Qt5::Gui Qt5::Core Qt5::Quick)

## quickflux 1.1.3%2Bgit20201110.2a37acf

=== debian/control ===
Source: quickflux
Section: libs
Priority: optional
Maintainer: Debian UBports Team <team+ubports@tracker.debian.org>
Uploaders: Mike Gabriel <sunweaver@debian.org>,
Build-Depends: debhelper-compat (= 13),
               cmake,
               qdoc-qt5,
               qtbase5-dev,
               qtdeclarative5-dev,
               qtdeclarative5-dev-tools,
Standards-Version: 4.6.2
Rules-Requires-Root: no
Homepage: https://github.com/benlau/quickflux
Vcs-Git: https://salsa.debian.org/ubports-team/quickflux.git
Vcs-Browser: https://salsa.debian.org/ubports-team/quickflux/

Package: qml-module-quickflux
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends},
         qml-module-qtquick2,
Description: quickflux QML/QtQuick module
 An implementation of Flux Application Architecture Framework from
 Facebook. It turns your QML application into a more modern and
 structured way.
 .
 This package contains the QML module for quickflux.

Package: quickflux-doc
Section: doc
Architecture: all
Depends: ${misc:Depends},
Description: quickflux API documentation and examples
 An implementation of Flux Application Architecture Framework from
 Facebook. It turns your QML application into a more modern and
 structured way.
 .
 This package contains the API documentation and some example projects.

## quickflux 1.1.3+git20201110.2a37acf

=== debian/changelog ===
quickflux (1.1.3+git20201110.2a37acf-2) unstable; urgency=medium

  * debian/patches:
    + Improve patch as suggested by @OPNA2608.
  * debian/rules:
    + Ignore failures when removing installed example files during bin:arch-only
      builds. (Closes: #1068723).
    + Adjust CMake build option (quickflux_BUILD_SHARED -> BUILD_SHARED_LIBS).

 -- Mike Gabriel <sunweaver@debian.org>  Wed, 10 Apr 2024 23:17:41 +0200

quickflux (1.1.3+git20201110.2a37acf-1) unstable; urgency=low

  * Initial upload to Debian. (Closes: #1068261).

 -- Mike Gabriel <sunweaver@debian.org>  Tue, 02 Apr 2024 22:45:59 +0200

=== debian/control ===
--- 
+++ 
@@ -15,12 +15,38 @@
 Vcs-Git: https://salsa.debian.org/ubports-team/quickflux.git
 Vcs-Browser: https://salsa.debian.org/ubports-team/quickflux/
 
+Package: libquickflux1
+Architecture: any
+Multi-Arch: same
+Depends: ${misc:Depends},
+         ${shlibs:Depends},
+Description: Flux implementation for QML
+ An implementation of Flux Application Architecture Framework from
+ Facebook. It turns your QML application into a more modern and
+ structured way.
+ .
+ This package contains the shared library files.
+
+Package: libquickflux-dev
+Section: libdevel
+Architecture: any
+Multi-Arch: same
+Depends: ${misc:Depends},
+         libquickflux1 (= ${binary:Version}),
+Description: Flux implementation for QML (development headers)
+ An implementation of Flux Application Architecture Framework from
+ Facebook. It turns your QML application into a more modern and
+ structured way.
+ .
+ This package contains the development header files of the quickflux shared
+ library.
+
 Package: qml-module-quickflux
 Architecture: any
 Multi-Arch: same
 Depends: ${misc:Depends},
-         ${shlibs:Depends},
          qml-module-qtquick2,
+         libquickflux1 (= ${binary:Version}),
 Description: quickflux QML/QtQuick module
  An implementation of Flux Application Architecture Framework from
  Facebook. It turns your QML application into a more modern and

=== debian/rules ===
#!/usr/bin/make -f

NULL =

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure --			\
	    -DBUILD_SHARED_LIBS=ON		\
	    $(NULL)

override_dh_auto_build:
	dh_auto_build
	cd docs && qdoc quickflux.qdocconf

override_dh_missing:
	dh_missing --fail-missing

override_dh_clean:
	dh_clean
	rm docs/html/ -Rfv

override_dh_installexamples:
	dh_installexamples
	-rm debian/quickflux-doc/usr/share/doc/quickflux-doc/examples/middleware/.gitignore
	-rm debian/quickflux-doc/usr/share/doc/quickflux-doc/examples/photoalbum/.gitignore
	-rm debian/quickflux-doc/usr/share/doc/quickflux-doc/examples/todo/.gitignore

get-orig-source:
	uscan --noconf --force-download --rename --download-current-version --repack --destdir=..

=== debian/watch ===
version=4
opts="mode=git, pgpmode=none,  pretty=1.1.3+git%cd.%h" \
https://github.com/benlau/quickflux.git \
heads/master debian uupdate
